\section{Performance}\label{sec:performance}
To evaluate the viability of the proposed policy management and data protection model, we carried out 
%four 
two different sets of performance evaluation experiments on a machine equipped with 16 GB of RAM and \textit{Intel Core i7 \textregistered 9750H @ 2.60GHz} CPU, running Ubuntu Linux operating system.
In the first set of experiments we have evaluated the performance of the \ac{pdp} in standalone mode.
In this experiment set, first test was conducted as a control reference, in which only a usage policy was evaluated without any administrative policies.
In the other tests, the number of administrative policies included in the evaluation was increased from one up to three policies.
The usage policy that was used in the experiment uses four string attributes, while each of the administrative policies uses five string attributes.
The experiments were conducted without any optimisation of the reduction algorithm described in Listing \ref{lst:evaluationReduction}.

The results are shown in Figure \ref{fig:pdp-perf-ad} which illustrates the time required to fully evaluate a usage policy with different administration levels.
It can be noticed that the required time is negligible and increases linearly, as expected, when the number of administrative policies increases.
To evaluate an administrative policy, a new request has to be crafted, which introduces an overhead to the usage policy evaluation.
However, this is one of the aspects that can be further optimised by exploiting caching, parallel evaluation or other policy features to make the system faster.


\begin{figure}[!htb]
    \centering
    \includegraphics[scale=0.43]{images/test-pdp.png}
    \caption{Administrative delegation performance impact on PDP evaluation}
    \label{fig:pdp-perf-ad}
    \centering
\end{figure}

In addition to the conducted experiments, we also measured the overall full flow evaluation of a usage policy with an increasing number of administrative policies.
The policies used in this measurement are the same policies used in the aforementioned experiments.e
Figure \ref{fig:ucs-perf-ad} illustrates the results and shows that the performance does not vary significantly when the number of administrative policies increases.
The results also show that the overall time required to evaluate a usage policy and to reach the root-of-trust administrative policy is no more than 0.5ms.
This shows that the overhead introduced by our model can be tolerated although further optimisations are also possible.

\begin{figure}[!htb]
    \centering
    \includegraphics[scale=0.41]{images/test-ucs.png}
    \caption{Administrative delegation performance impact on UCS full flow}
    \label{fig:ucs-perf-ad}
    \centering
\end{figure}
